#version 330 core

layout(location=0) out vec4 outColor;

in vec2 texCoord;
uniform sampler2D texture;
uniform float kernel[7];
uniform vec2 offset;

void main()
{
	vec4 color;
    vec2 tc = texCoord.st;

    color  = kernel[0] * texture2D(texture, tc - 3*offset);
    color += kernel[1] * texture2D(texture, tc - 2*offset);
    color += kernel[2] * texture2D(texture, tc - offset);
	color += kernel[3] * texture2D(texture, tc);
	color += kernel[4] * texture2D(texture, tc + offset);
	color += kernel[5] * texture2D(texture, tc + 2*offset);
	color += kernel[6] * texture2D(texture, tc + 3*offset);

    outColor = color;
}