#version 330 core

layout(location=0) out vec4 outColor;

in vec2 texCoord;
uniform sampler2D texture;
uniform float threshold;

void main()
{
	float lum = (texture2D(texture, texCoord).r + texture2D(texture, texCoord).g + texture2D(texture, texCoord).b) / 3.00;
	//float r = texture2D(texture, texCoord).r > threshold ? texture2D(texture, texCoord).r : 0;
	//float g = texture2D(texture, texCoord).g > threshold ? texture2D(texture, texCoord).g : 0;
	//float b = texture2D(texture, texCoord).b > threshold ? texture2D(texture, texCoord).b : 0;
	//float a = texture2D(texture, texCoord).a;
	vec4 color;
	if (lum >= threshold)
	{
		lum = lum-threshold;
		color = vec4(lum, lum, lum, texture2D(texture, texCoord).a);
	}
	else
		color = vec4(0.0,0.0,0.0,0.0);
	
    outColor = color;
}