#version 330 core

layout(location=0) out vec4 outColor;

in vec2 texCoord;
uniform sampler2D texture;
uniform sampler2D texture2;
uniform float exposure;
uniform float minLuminance;
uniform float meanLuminance;
uniform float maxLuminance;

void main()
{
	
	// Colored bloom
	vec4 color = texture2D(texture, texCoord);
	vec4 whiteBloom = texture2D(texture2, texCoord);
	color += vec4(whiteBloom.rgb, 0.0);
	
	
	float Y = dot(vec4(0.30, 0.59, 0.11, 0.0), color);
	float YD = exposure * (exposure/maxLuminance + 1.0) / (exposure + 1.0);
	color.r *= YD;
	color.g *= YD;
	color.b *= YD;
	
	//color = color / maxLuminance;
	//color = color * (0.18/meanLuminance);
	//color = color / (1+color);
	//color = (color*(1+(color/maxLuminance)))/(1+color);
	outColor = color;
}