#version 330 core

// Scales the image to 1/2 size and preserves the max luminance

layout(location=0) out vec4 outColor;

in vec2 texCoord;
uniform sampler2D texture;
uniform int width;
uniform int height;

void main()
{
	float lum;
	float p1 = 0.0;
	float p2 = 0.0;
	float p3 = 0.0;
	float p4 = 0.0;
	vec4 pTmp = vec4(0.0, 0.0, 0.0, 0.0);
	float maxLum = 0.00;
	vec2 coord = texCoord;
	
	pTmp = texture2D(texture, coord);
	p1 = pTmp.a < 0.01 ? (pTmp.r + pTmp.g + pTmp.b) / 3.00 : 0.0;
	
	coord.s = texCoord.s + 1.0/(width*2);
	pTmp = texture2D(texture, coord);
	p2 = pTmp.a < 0.01 ? (pTmp.r + pTmp.g + pTmp.b) / 3.00 : 0.0;
	
	coord.s = texCoord.s;
	coord.t = texCoord.t + 1.0/(height*2);
	pTmp = texture2D(texture, coord);
	p3 = pTmp.a < 0.01 ? (pTmp.r + pTmp.g + pTmp.b) / 3.00 : 0.0;
	
	coord.s = texCoord.s + 1.0/(width*2);
	pTmp = texture2D(texture, coord);
	p4 = pTmp.a < 0.01 ? (pTmp.r + pTmp.g + pTmp.b) / 3.00 : 0.0;
	
	maxLum = max(p1,p2);
	maxLum = max(maxLum, p3);
	maxLum = max(maxLum, p4);
	
    outColor = vec4(maxLum, maxLum, maxLum, 0.0);
}