#version 330 core

layout (location = 0) in vec3 position;
layout (location = 1) in vec2 uv;
layout (location = 2) in vec3 normal;
layout (location = 3) in mat4 model;
layout (location = 7) in vec3 tangent;
layout (location = 8) in vec3 bitangent;

uniform mat4 view;
uniform mat4 projection;

void main()
{
	mat4 mvp = projection*view*model;
    gl_Position = mvp * vec4(position, 1.0);
}