#version 330 core

uniform mat4 view;
uniform mat4 projection;
uniform vec3 quad1, quad2;
uniform float size;

layout(points) in;
layout(triangle_strip, max_vertices = 4) out;

in vec4 outColor[];
smooth out vec2 texCoord;
flat out vec4 colorPart;

void main()
{
	vec3 posOld = gl_in[0].gl_Position.xyz;
	//float size = 1.0f;
	mat4 mvp = projection * view;
	
	colorPart = outColor[0];
	
	vec3 pos = posOld+(-quad1-quad2)*size;
	texCoord = vec2(0.0, 0.0);
    gl_Position = mvp*vec4(pos, 1.0);
    EmitVertex();
    
    pos = posOld+(-quad1+quad2)*size;
    texCoord = vec2(0.0, 1.0);
    gl_Position = mvp*vec4(pos, 1.0);
    EmitVertex();
    
    pos = posOld+(quad1-quad2)*size;
    texCoord = vec2(1.0, 0.0);
    gl_Position = mvp*vec4(pos, 1.0);
    EmitVertex();
    
    pos = posOld+(quad1+quad2)*size;
    texCoord = vec2(1.0, 1.0);
    gl_Position = mvp*vec4(pos, 1.0);
    EmitVertex();
      
    EndPrimitive(); 
}